Project Chrono: chrono::vehicle::ChRotationalDamperSuspension Class Reference

Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | List of all members
chrono::vehicle::ChRotationalDamperSuspension Class Referenceabstract
VEHICLE module » Tracked vehicles » Suspension subsystem

## Description

Base class for a torsion-bar suspension system using a rotational damper (template definition).

`#include <ChRotationalDamperSuspension.h>`

Inheritance diagram for chrono::vehicle::ChRotationalDamperSuspension:
[legend]
Collaboration diagram for chrono::vehicle::ChRotationalDamperSuspension:
[legend]

## Public Member Functions
| ChRotationalDamperSuspension (const std::string &name, bool has_shock=true, bool lock_arm=false)
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual std::shared_ptr< ChBody > | GetCarrierBody () const override
| Get a handle to the carrier body.
virtual double | GetCarrierAngle () const override
| Return the current pitch angle of the carrier body.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, const ChVector3d &location, ChTrackAssembly *track) override
| Initialize this suspension subsystem.
virtual ForceTorque | ReportSuspensionForce () const override
| Return current suspension forces or torques, as appropriate (spring and shock).
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the suspension subsystem.
virtual void | RemoveVisualizationAssets () override final
| Remove visualization assets for the suspension subsystem.
void | LogConstraintViolations () override
| Log current constraint violations.
Public Member Functions inherited from chrono::vehicle::ChTrackSuspension
GuidePinType | GetType () const
| Return the type of track shoe consistent with this road wheel.
std::shared_ptr< ChTrackWheel > | GetRoadWheel () const
| Return a handle to the road wheel subsystem.
std::shared_ptr< ChBody > | GetWheelBody () const
| Return the body of the idler wheel.
std::shared_ptr< ChLinkLockRevolute > | GetWheelRevolute () const
| Get a handle to the revolute joint of the road-wheel.
double | GetWheelRadius () const
| Get the radius of the road wheel.
virtual void | SetOutput (bool state) override
| Enable/disable output for this subsystem.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Protected Types
enum | PointId { ARM , ARM_WHEEL , ARM_CHASSIS , NUM_POINTS }
| Identifiers for the various hardpoints. More...

## Protected Member Functions
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
virtual const ChVector3d | GetLocation (PointId which)=0
| Return the location of the specified hardpoint.
virtual double | GetArmMass () const =0
| Return the mass of the arm body.
virtual const ChVector3d & | GetArmInertia () const =0
| Return the moments of inertia of the arm body.
virtual double | GetArmVisRadius () const =0
| Return a visualization radius for the arm body.
virtual double | GetSpringRestAngle () const =0
| Return the free (rest) angle of the spring element.
virtual std::shared_ptr< ChLinkRSDA::TorqueFunctor > | GetSpringTorqueFunctor () const =0
| Return the functor object for the torsional spring torque.
virtual std::shared_ptr< ChLinkRSDA::TorqueFunctor > | GetShockTorqueCallback () const =0
| Return the functor object for the rotational shock force.
virtual std::shared_ptr< ChVehicleBushingData > | getArmBushingData () const
| Return stiffness and damping data for the arm bushing.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const override
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const override
| Output data for this subsystem's component list to the specified database.
Protected Member Functions inherited from chrono::vehicle::ChTrackSuspension
| ChTrackSuspension (const std::string &name, bool has_shock, bool lock_arm)
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.

## Protected Attributes
std::shared_ptr< ChBody > | m_arm
| trailing arm body
std::shared_ptr< ChVehicleJoint > | m_joint
| joint arm-chassis
std::shared_ptr< ChLinkRSDA > | m_spring
| rotational spring link
std::shared_ptr< ChLinkRSDA > | m_shock
| rotational shock link
Protected Attributes inherited from chrono::vehicle::ChTrackSuspension
GuidePinType | m_type
| type of the track shoe matching this road wheel
bool | m_has_shock
| specifies whether or not the suspension has a damper
bool | m_lock_arm
| specified whether the suspension arm is locked
ChVector3d | m_rel_loc
| suspension subsystem location relative to chassis
std::shared_ptr< ChTrackWheel > | m_road_wheel
| road-wheel subsystem
ChTrackAssembly * | m_track
| containing track assembly
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).

## Member Enumeration Documentation

## ◆ PointId

enum chrono::vehicle::ChRotationalDamperSuspension::PointId
| protected

Identifiers for the various hardpoints.

Enumerator
ARM | arm location
ARM_WHEEL | arm, connection point to road wheel
ARM_CHASSIS | arm, connection point to chassis

## Constructor & Destructor Documentation

## ◆ ChRotationalDamperSuspension()

chrono::vehicle::ChRotationalDamperSuspension::ChRotationalDamperSuspension | ( | const std::string & | name,
|  | bool | has_shock = true,
|  | bool | lock_arm = false )

Parameters

  [in] | name | name of the subsystem
  [in] | has_shock | specify whether or not the suspension has a damper
  [in] | lock_arm | if true, the suspension arm is locked

## Member Function Documentation

## ◆ AddVisualizationAssets()

void chrono::vehicle::ChRotationalDamperSuspension::AddVisualizationAssets | ( | VisualizationType | vis | ) |
| overridevirtual

Add visualization assets for the suspension subsystem.

Reimplemented from chrono::vehicle::ChPart.

## ◆ ExportComponentList()

void chrono::vehicle::ChRotationalDamperSuspension::ExportComponentList | ( | rapidjson::Document & | jsonDocument | ) | const
| overrideprotectedvirtual

Export this subsystem's component list to the specified JSON object.

Derived classes should override this function and first invoke the base class implementation, followed by calls to the various static Export***List functions, as appropriate.

Reimplemented from chrono::vehicle::ChTrackSuspension.

## ◆ getArmBushingData()

virtual std::shared_ptr< ChVehicleBushingData > chrono::vehicle::ChRotationalDamperSuspension::getArmBushingData | ( |  | ) | const
| inlineprotectedvirtual

Return stiffness and damping data for the arm bushing.

Returning nullptr (default) results in using a kinematic revolute joint.

## ◆ GetArmInertia()

virtual const ChVector3d & chrono::vehicle::ChRotationalDamperSuspension::GetArmInertia | ( |  | ) | const
| protectedpure virtual

Return the moments of inertia of the arm body.

Implemented in chrono::vehicle::RotationalDamperSuspension.

## ◆ GetArmMass()

virtual double chrono::vehicle::ChRotationalDamperSuspension::GetArmMass | ( |  | ) | const
| protectedpure virtual

Return the mass of the arm body.

Implemented in chrono::vehicle::RotationalDamperSuspension.

## ◆ GetArmVisRadius()

virtual double chrono::vehicle::ChRotationalDamperSuspension::GetArmVisRadius | ( |  | ) | const
| protectedpure virtual

Return a visualization radius for the arm body.

Implemented in chrono::vehicle::RotationalDamperSuspension.

## ◆ GetCarrierAngle()

double chrono::vehicle::ChRotationalDamperSuspension::GetCarrierAngle | ( |  | ) | const
| overridevirtual

Return the current pitch angle of the carrier body.

This angle is measured in the x-z transversal plane, from the initial configuration, and follows the right-hand rule.

Implements chrono::vehicle::ChTrackSuspension.

## ◆ GetCarrierBody()

virtual std::shared_ptr< ChBody > chrono::vehicle::ChRotationalDamperSuspension::GetCarrierBody | ( |  | ) | const
| inlineoverridevirtual

Get a handle to the carrier body.

Implements chrono::vehicle::ChTrackSuspension.

## ◆ GetLocation()

virtual const ChVector3d chrono::vehicle::ChRotationalDamperSuspension::GetLocation | ( | PointId | which | ) |
| protectedpure virtual

Return the location of the specified hardpoint.

The returned location must be expressed in the idler subsystem reference frame.

## ◆ GetShockTorqueCallback()

virtual std::shared_ptr< ChLinkRSDA::TorqueFunctor > chrono::vehicle::ChRotationalDamperSuspension::GetShockTorqueCallback | ( |  | ) | const
| protectedpure virtual

Return the functor object for the rotational shock force.

Implemented in chrono::vehicle::RotationalDamperSuspension.

## ◆ GetSpringRestAngle()

virtual double chrono::vehicle::ChRotationalDamperSuspension::GetSpringRestAngle | ( |  | ) | const
| protectedpure virtual

Return the free (rest) angle of the spring element.

Implemented in chrono::vehicle::RotationalDamperSuspension.

## ◆ GetSpringTorqueFunctor()

virtual std::shared_ptr< ChLinkRSDA::TorqueFunctor > chrono::vehicle::ChRotationalDamperSuspension::GetSpringTorqueFunctor | ( |  | ) | const
| protectedpure virtual

Return the functor object for the torsional spring torque.

Implemented in chrono::vehicle::RotationalDamperSuspension.

## ◆ GetTemplateName()

virtual std::string chrono::vehicle::ChRotationalDamperSuspension::GetTemplateName | ( |  | ) | const
| inlineoverridevirtual

Get the name of the vehicle subsystem template.

Implements chrono::vehicle::ChPart.

## ◆ Initialize()

void chrono::vehicle::ChRotationalDamperSuspension::Initialize | ( | std::shared_ptr< ChChassis > | chassis,
|  | const ChVector3d & | location,
|  | ChTrackAssembly * | track )
| overridevirtual

Initialize this suspension subsystem.

The suspension subsystem is initialized by attaching it to the specified chassis body at the specified location (with respect to and expressed in the reference frame of the chassis). It is assumed that the suspension reference frame is always centered at the location of the road wheel and aligned with the chassis reference frame.

Parameters

  [in] | chassis | associated chassis subsystem
  [in] | location | location relative to the chassis frame
  [in] | track | containing track assembly

Reimplemented from chrono::vehicle::ChTrackSuspension.

## ◆ InitializeInertiaProperties()

void chrono::vehicle::ChRotationalDamperSuspension::InitializeInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Initialize subsystem inertia properties.

Derived classes must override this function and set the subsystem mass (m_mass) and, if constant, the subsystem COM frame and its inertia tensor. This function is called during initialization of the vehicle system.

Implements chrono::vehicle::ChPart.

## ◆ LogConstraintViolations()

void chrono::vehicle::ChRotationalDamperSuspension::LogConstraintViolations | ( |  | ) |
| overridevirtual

Log current constraint violations.

Implements chrono::vehicle::ChTrackSuspension.

## ◆ Output()

void chrono::vehicle::ChRotationalDamperSuspension::Output | ( | ChVehicleOutput & | database | ) | const
| overrideprotectedvirtual

Output data for this subsystem's component list to the specified database.

Reimplemented from chrono::vehicle::ChPart.

## ◆ RemoveVisualizationAssets()

void chrono::vehicle::ChRotationalDamperSuspension::RemoveVisualizationAssets | ( |  | ) |
| finaloverridevirtual

Remove visualization assets for the suspension subsystem.

Reimplemented from chrono::vehicle::ChPart.

## ◆ ReportSuspensionForce()

ChTrackSuspension::ForceTorque chrono::vehicle::ChRotationalDamperSuspension::ReportSuspensionForce | ( |  | ) | const
| overridevirtual

Return current suspension forces or torques, as appropriate (spring and shock).

A ChRotationalDamperSuspension returns torques for both the spring and the damper.

Implements chrono::vehicle::ChTrackSuspension.

## ◆ UpdateInertiaProperties()

void chrono::vehicle::ChRotationalDamperSuspension::UpdateInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Update subsystem inertia properties.

Derived classes must override this function and set the global subsystem transform (m_xform) and, unless constant, the subsystem COM frame (m_com) and its inertia tensor (m_inertia). Calculate the current inertia properties and global frame of this subsystem. This function is called every time the state of the vehicle system is advanced in time.

Implements chrono::vehicle::ChPart.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/suspension/ChRotationalDamperSuspension.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/suspension/ChRotationalDamperSuspension.cpp